from django.conf.urls import patterns, include, url

from django.conf import settings
from django.conf.urls.static import static

urlpatterns = patterns('',
    url(r'^$', 'errors.views.main'),
    url(r'^bucket/$', 'errors.views.bucket'),
    url(r'^oops/(.*)$', 'errors.views.oops'),
    url(r'^main$', 'errors.views.main'),
    url(r'^api/', include('errors.api.urls')),
    url(r'^user/(.*)$', 'errors.views.user'),
    url(r'^retracers-average-processing-time/', 'errors.views.retracers_average_processing_time'),
    url(r'^retracers-results/', 'errors.views.retracers_results'),
    url(r'^ops/instances/', 'errors.views.instances_count'),
    url(r'^openid/', include('django_openid_auth.urls')),
    url(r'^logout/', 'errors.views.logout_view'),
    url(r'^filter/(.*)$', 'errors.views.main'),
    url(r'^status/?$', 'errors.views.status'),
    url(r'^login-failed/?$', 'errors.views.login_failed'),
    url(r'^bug/(.*)$', 'errors.views.bug'),
    url(r'problem/(.*)$', 'errors.views.problem'),
) + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

# If we get a request for static content, handle it. This will happen if Apache
# does not have an alias defined for /static, such as when we're using gunicorn
# instead of Apache.
urlpatterns += patterns('', (r'^static/(?P<path>.*)$',
                             'django.views.static.serve',
                             {'document_root': 'static'}))
